<?php
// $Id: taxonomy_split.panels_default.inc,v 1.1 2010/06/27 19:50:43 hutch Exp $
// $Name: DRUPAL-6--1-0 $

/**
 * @file
 * Hook into panels
 * Bulk export of panels_default objects generated by Bulk export module.
 * @author Bob Hutchinson http://drupal.org/user/52366
 */

/**
 * Implementation of hook_default_panels_mini().
 */
function taxonomy_split_default_panels_mini() {

  // we need one for each enabled panels
  $allowed_vids = taxonomy_split_get_allowed_panels();
  $description = variable_get('taxonomy_split_panel_description', t('Click on a category to see more'));
  $minis = array();
  foreach ($allowed_vids AS $vid => $vidname) {

    $mini = new stdClass;
    $mini->disabled = FALSE; /* Edit this to true to make a default mini disabled initially */
    $mini->api_version = 1;
    $mini->name = 'taxonomy_split_'. $vid;
    $mini->category = '';
    $mini->title = 'Taxonomy Split '. $vidname;
    $mini->requiredcontexts = FALSE;
    $mini->contexts = FALSE;
    $mini->relationships = FALSE;
    $display = new panels_display;
    $display->layout = 'taxonomy_split';
    $display->layout_settings = array();
    $display->panel_settings = array();
    $display->cache = array();
    $display->title = '';
    $display->content = array();
    $display->panels = array();
      // lhs pane
      $pane = new stdClass;
      $pane->pid = 'taxonomy_split-1-'. $vid;
      $pane->panel = 'left';
      $pane->type = 'custom';
      $pane->subtype = 'custom';
      $pane->shown = TRUE;
      $pane->access = array();
      $pane->configuration = array(
        'admin_title' => '',
        'title' => "$vidname" ,
        'body' => '<div id="ts_left_'. $vid .'"><?php echo taxonomy_split_get_parents('. $vid .', \'panel\'); ?></div>
<p class="description">'. $description .'</p>
',
        'format' => '3',
        'substitute' => TRUE,
      );
      $pane->cache = array();
      $pane->style = array(
        'style' => 'default',
      );
      $pane->css = array();
      $pane->extras = array();
      $pane->position = 0;
      $display->content['taxonomy_split-1-'. $vid] = $pane;
      $display->panels['left'][0] = 'taxonomy_split-1-'. $vid;
      // middle pane
      $pane = new stdClass;
      $pane->pid = 'taxonomy_split-2-'. $vid;
      $pane->panel = 'middle';
      $pane->type = 'custom';
      $pane->subtype = 'custom';
      $pane->shown = TRUE;
      $pane->access = array();
      $pane->configuration = array(
        'admin_title' => '',
        'title' => '',
        'body' => '<div id="ts_middle_'. $vid .'"><h2></h2><div class="content"></div></div>',
        'format' => '2',
        'substitute' => TRUE,
      );
      $pane->cache = array();
      $pane->style = array();
      $pane->css = array();
      $pane->extras = array();
      $pane->position = 0;
      $display->content['taxonomy_split-2-'. $vid] = $pane;
      $display->panels['middle'][0] = 'taxonomy_split-2-'. $vid;
      // rhs pane
      $pane = new stdClass;
      $pane->pid = 'taxonomy_split-3';
      $pane->panel = 'right';
      $pane->type = 'custom';
      $pane->subtype = 'custom';
      $pane->shown = TRUE;
      $pane->access = array();
      $pane->configuration = array(
        'admin_title' => '',
        'title' => '',
        'body' => '<div id="ts_right_'. $vid .'"><h2></h2><div class="content"></div></div>',
        'format' => '2',
        'substitute' => TRUE,
      );
      $pane->cache = array();
      $pane->style = array();
      $pane->css = array();
      $pane->extras = array();
      $pane->position = 0;
      $display->content['taxonomy_split-3-'. $vid] = $pane;
      $display->panels['right'][0] = 'taxonomy_split-3-'. $vid;
    $display->hide_title = PANELS_TITLE_NONE;
    $display->title_pane = '0';
    $mini->display = $display;
    $minis['taxonomy_split_'. $vid] = $mini;
  }
  return $minis;
}
